# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class ComputersMacosResponseMixin(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'Links',
        'embedded': 'dict(str, object)',
        'uuid': 'str',
        'object_type': 'str',
        'uri': 'str'
    }

    attribute_map = {
        'links': '_links',
        'embedded': '_embedded',
        'uuid': 'uuid',
        'object_type': 'objectType',
        'uri': 'uri'
    }

    def __init__(self, links=None, embedded=None, uuid=None, object_type=None, uri=None, local_vars_configuration=None):  # noqa: E501
        """ComputersMacosResponseMixin - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._embedded = None
        self._uuid = None
        self._object_type = None
        self._uri = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if embedded is not None:
            self.embedded = embedded
        if uuid is not None:
            self.uuid = uuid
        if object_type is not None:
            self.object_type = object_type
        if uri is not None:
            self.uri = uri

    @property
    def links(self):
        """Gets the links of this ComputersMacosResponseMixin.  # noqa: E501


        :return: The links of this ComputersMacosResponseMixin.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ComputersMacosResponseMixin.


        :param links: The links of this ComputersMacosResponseMixin.  # noqa: E501
        :type links: Links
        """

        self._links = links

    @property
    def embedded(self):
        """Gets the embedded of this ComputersMacosResponseMixin.  # noqa: E501

        Hypertext Application Language (HAL) embedded resources.  # noqa: E501

        :return: The embedded of this ComputersMacosResponseMixin.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._embedded

    @embedded.setter
    def embedded(self, embedded):
        """Sets the embedded of this ComputersMacosResponseMixin.

        Hypertext Application Language (HAL) embedded resources.  # noqa: E501

        :param embedded: The embedded of this ComputersMacosResponseMixin.  # noqa: E501
        :type embedded: dict(str, object)
        """

        self._embedded = embedded

    @property
    def uuid(self):
        """Gets the uuid of this ComputersMacosResponseMixin.  # noqa: E501

        The LDAP Entry-UUID.  # noqa: E501

        :return: The uuid of this ComputersMacosResponseMixin.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this ComputersMacosResponseMixin.

        The LDAP Entry-UUID.  # noqa: E501

        :param uuid: The uuid of this ComputersMacosResponseMixin.  # noqa: E501
        :type uuid: str
        """
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and len(uuid) > 36):
            raise ValueError("Invalid value for `uuid`, length must be less than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and len(uuid) < 36):
            raise ValueError("Invalid value for `uuid`, length must be greater than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and not re.search(r'^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$', uuid)):  # noqa: E501
            raise ValueError(r"Invalid value for `uuid`, must be a follow pattern or equal to `/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/`")  # noqa: E501

        self._uuid = uuid

    @property
    def object_type(self):
        """Gets the object_type of this ComputersMacosResponseMixin.  # noqa: E501

        The UDM Object-Type.  # noqa: E501

        :return: The object_type of this ComputersMacosResponseMixin.  # noqa: E501
        :rtype: str
        """
        return self._object_type

    @object_type.setter
    def object_type(self, object_type):
        """Sets the object_type of this ComputersMacosResponseMixin.

        The UDM Object-Type.  # noqa: E501

        :param object_type: The object_type of this ComputersMacosResponseMixin.  # noqa: E501
        :type object_type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                object_type is not None and len(object_type) < 3):
            raise ValueError("Invalid value for `object_type`, length must be greater than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                object_type is not None and not re.search(r'^.+\/.+$', object_type)):  # noqa: E501
            raise ValueError(r"Invalid value for `object_type`, must be a follow pattern or equal to `/^.+\/.+$/`")  # noqa: E501

        self._object_type = object_type

    @property
    def uri(self):
        """Gets the uri of this ComputersMacosResponseMixin.  # noqa: E501


        :return: The uri of this ComputersMacosResponseMixin.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this ComputersMacosResponseMixin.


        :param uri: The uri of this ComputersMacosResponseMixin.  # noqa: E501
        :type uri: str
        """

        self._uri = uri

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComputersMacosResponseMixin):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ComputersMacosResponseMixin):
            return True

        return self.to_dict() != other.to_dict()
