# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class ComputersMemberserverPolicies(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'policies_printserver': 'list[str]',
        'policies_repositorysync': 'list[str]',
        'policies_nfsmounts': 'list[str]',
        'policies_memberpackages': 'list[str]',
        'policies_umc': 'list[str]',
        'policies_maintenance': 'list[str]',
        'policies_release': 'list[str]',
        'policies_registry': 'list[str]',
        'policies_ldapserver': 'list[str]',
        'policies_repositoryserver': 'list[str]'
    }

    attribute_map = {
        'policies_printserver': 'policies/printserver',
        'policies_repositorysync': 'policies/repositorysync',
        'policies_nfsmounts': 'policies/nfsmounts',
        'policies_memberpackages': 'policies/memberpackages',
        'policies_umc': 'policies/umc',
        'policies_maintenance': 'policies/maintenance',
        'policies_release': 'policies/release',
        'policies_registry': 'policies/registry',
        'policies_ldapserver': 'policies/ldapserver',
        'policies_repositoryserver': 'policies/repositoryserver'
    }

    def __init__(self, policies_printserver=None, policies_repositorysync=None, policies_nfsmounts=None, policies_memberpackages=None, policies_umc=None, policies_maintenance=None, policies_release=None, policies_registry=None, policies_ldapserver=None, policies_repositoryserver=None, local_vars_configuration=None):  # noqa: E501
        """ComputersMemberserverPolicies - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._policies_printserver = None
        self._policies_repositorysync = None
        self._policies_nfsmounts = None
        self._policies_memberpackages = None
        self._policies_umc = None
        self._policies_maintenance = None
        self._policies_release = None
        self._policies_registry = None
        self._policies_ldapserver = None
        self._policies_repositoryserver = None
        self.discriminator = None

        if policies_printserver is not None:
            self.policies_printserver = policies_printserver
        if policies_repositorysync is not None:
            self.policies_repositorysync = policies_repositorysync
        if policies_nfsmounts is not None:
            self.policies_nfsmounts = policies_nfsmounts
        if policies_memberpackages is not None:
            self.policies_memberpackages = policies_memberpackages
        if policies_umc is not None:
            self.policies_umc = policies_umc
        if policies_maintenance is not None:
            self.policies_maintenance = policies_maintenance
        if policies_release is not None:
            self.policies_release = policies_release
        if policies_registry is not None:
            self.policies_registry = policies_registry
        if policies_ldapserver is not None:
            self.policies_ldapserver = policies_ldapserver
        if policies_repositoryserver is not None:
            self.policies_repositoryserver = policies_repositoryserver

    @property
    def policies_printserver(self):
        """Gets the policies_printserver of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Print server  # noqa: E501

        :return: The policies_printserver of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_printserver

    @policies_printserver.setter
    def policies_printserver(self, policies_printserver):
        """Sets the policies_printserver of this ComputersMemberserverPolicies.

        Policy: Print server  # noqa: E501

        :param policies_printserver: The policies_printserver of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_printserver: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_printserver is not None and len(policies_printserver) > 1):
            raise ValueError("Invalid value for `policies_printserver`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_printserver is not None and len(policies_printserver) < 0):
            raise ValueError("Invalid value for `policies_printserver`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_printserver = policies_printserver

    @property
    def policies_repositorysync(self):
        """Gets the policies_repositorysync of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Repository synchronisation  # noqa: E501

        :return: The policies_repositorysync of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_repositorysync

    @policies_repositorysync.setter
    def policies_repositorysync(self, policies_repositorysync):
        """Sets the policies_repositorysync of this ComputersMemberserverPolicies.

        Policy: Repository synchronisation  # noqa: E501

        :param policies_repositorysync: The policies_repositorysync of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_repositorysync: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_repositorysync is not None and len(policies_repositorysync) > 1):
            raise ValueError("Invalid value for `policies_repositorysync`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_repositorysync is not None and len(policies_repositorysync) < 0):
            raise ValueError("Invalid value for `policies_repositorysync`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_repositorysync = policies_repositorysync

    @property
    def policies_nfsmounts(self):
        """Gets the policies_nfsmounts of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: NFS mounts  # noqa: E501

        :return: The policies_nfsmounts of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_nfsmounts

    @policies_nfsmounts.setter
    def policies_nfsmounts(self, policies_nfsmounts):
        """Sets the policies_nfsmounts of this ComputersMemberserverPolicies.

        Policy: NFS mounts  # noqa: E501

        :param policies_nfsmounts: The policies_nfsmounts of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_nfsmounts: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_nfsmounts is not None and len(policies_nfsmounts) > 1):
            raise ValueError("Invalid value for `policies_nfsmounts`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_nfsmounts is not None and len(policies_nfsmounts) < 0):
            raise ValueError("Invalid value for `policies_nfsmounts`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_nfsmounts = policies_nfsmounts

    @property
    def policies_memberpackages(self):
        """Gets the policies_memberpackages of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Packages for Managed Nodes  # noqa: E501

        :return: The policies_memberpackages of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_memberpackages

    @policies_memberpackages.setter
    def policies_memberpackages(self, policies_memberpackages):
        """Sets the policies_memberpackages of this ComputersMemberserverPolicies.

        Policy: Packages for Managed Nodes  # noqa: E501

        :param policies_memberpackages: The policies_memberpackages of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_memberpackages: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_memberpackages is not None and len(policies_memberpackages) > 1):
            raise ValueError("Invalid value for `policies_memberpackages`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_memberpackages is not None and len(policies_memberpackages) < 0):
            raise ValueError("Invalid value for `policies_memberpackages`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_memberpackages = policies_memberpackages

    @property
    def policies_umc(self):
        """Gets the policies_umc of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: UMC  # noqa: E501

        :return: The policies_umc of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_umc

    @policies_umc.setter
    def policies_umc(self, policies_umc):
        """Sets the policies_umc of this ComputersMemberserverPolicies.

        Policy: UMC  # noqa: E501

        :param policies_umc: The policies_umc of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_umc: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_umc is not None and len(policies_umc) > 1):
            raise ValueError("Invalid value for `policies_umc`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_umc is not None and len(policies_umc) < 0):
            raise ValueError("Invalid value for `policies_umc`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_umc = policies_umc

    @property
    def policies_maintenance(self):
        """Gets the policies_maintenance of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Maintenance  # noqa: E501

        :return: The policies_maintenance of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_maintenance

    @policies_maintenance.setter
    def policies_maintenance(self, policies_maintenance):
        """Sets the policies_maintenance of this ComputersMemberserverPolicies.

        Policy: Maintenance  # noqa: E501

        :param policies_maintenance: The policies_maintenance of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_maintenance: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_maintenance is not None and len(policies_maintenance) > 1):
            raise ValueError("Invalid value for `policies_maintenance`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_maintenance is not None and len(policies_maintenance) < 0):
            raise ValueError("Invalid value for `policies_maintenance`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_maintenance = policies_maintenance

    @property
    def policies_release(self):
        """Gets the policies_release of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Automatic updates  # noqa: E501

        :return: The policies_release of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_release

    @policies_release.setter
    def policies_release(self, policies_release):
        """Sets the policies_release of this ComputersMemberserverPolicies.

        Policy: Automatic updates  # noqa: E501

        :param policies_release: The policies_release of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_release: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_release is not None and len(policies_release) > 1):
            raise ValueError("Invalid value for `policies_release`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_release is not None and len(policies_release) < 0):
            raise ValueError("Invalid value for `policies_release`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_release = policies_release

    @property
    def policies_registry(self):
        """Gets the policies_registry of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Univention Configuration Registry  # noqa: E501

        :return: The policies_registry of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_registry

    @policies_registry.setter
    def policies_registry(self, policies_registry):
        """Sets the policies_registry of this ComputersMemberserverPolicies.

        Policy: Univention Configuration Registry  # noqa: E501

        :param policies_registry: The policies_registry of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_registry: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_registry is not None and len(policies_registry) > 1):
            raise ValueError("Invalid value for `policies_registry`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_registry is not None and len(policies_registry) < 0):
            raise ValueError("Invalid value for `policies_registry`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_registry = policies_registry

    @property
    def policies_ldapserver(self):
        """Gets the policies_ldapserver of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: LDAP server  # noqa: E501

        :return: The policies_ldapserver of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_ldapserver

    @policies_ldapserver.setter
    def policies_ldapserver(self, policies_ldapserver):
        """Sets the policies_ldapserver of this ComputersMemberserverPolicies.

        Policy: LDAP server  # noqa: E501

        :param policies_ldapserver: The policies_ldapserver of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_ldapserver: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_ldapserver is not None and len(policies_ldapserver) > 1):
            raise ValueError("Invalid value for `policies_ldapserver`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_ldapserver is not None and len(policies_ldapserver) < 0):
            raise ValueError("Invalid value for `policies_ldapserver`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_ldapserver = policies_ldapserver

    @property
    def policies_repositoryserver(self):
        """Gets the policies_repositoryserver of this ComputersMemberserverPolicies.  # noqa: E501

        Policy: Repository server  # noqa: E501

        :return: The policies_repositoryserver of this ComputersMemberserverPolicies.  # noqa: E501
        :rtype: list[str]
        """
        return self._policies_repositoryserver

    @policies_repositoryserver.setter
    def policies_repositoryserver(self, policies_repositoryserver):
        """Sets the policies_repositoryserver of this ComputersMemberserverPolicies.

        Policy: Repository server  # noqa: E501

        :param policies_repositoryserver: The policies_repositoryserver of this ComputersMemberserverPolicies.  # noqa: E501
        :type policies_repositoryserver: list[str]
        """
        if (self.local_vars_configuration.client_side_validation and
                policies_repositoryserver is not None and len(policies_repositoryserver) > 1):
            raise ValueError("Invalid value for `policies_repositoryserver`, number of items must be less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                policies_repositoryserver is not None and len(policies_repositoryserver) < 0):
            raise ValueError("Invalid value for `policies_repositoryserver`, number of items must be greater than or equal to `0`")  # noqa: E501

        self._policies_repositoryserver = policies_repositoryserver

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComputersMemberserverPolicies):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ComputersMemberserverPolicies):
            return True

        return self.to_dict() != other.to_dict()
