# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class InlineResponse201(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dn': 'str',
        'uuid': 'str'
    }

    attribute_map = {
        'dn': 'dn',
        'uuid': 'uuid'
    }

    def __init__(self, dn=None, uuid=None, local_vars_configuration=None):  # noqa: E501
        """InlineResponse201 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._dn = None
        self._uuid = None
        self.discriminator = None

        if dn is not None:
            self.dn = dn
        if uuid is not None:
            self.uuid = uuid

    @property
    def dn(self):
        """Gets the dn of this InlineResponse201.  # noqa: E501

        The LDAP Distinguished Name (DN).  # noqa: E501

        :return: The dn of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._dn

    @dn.setter
    def dn(self, dn):
        """Sets the dn of this InlineResponse201.

        The LDAP Distinguished Name (DN).  # noqa: E501

        :param dn: The dn of this InlineResponse201.  # noqa: E501
        :type dn: str
        """
        if (self.local_vars_configuration.client_side_validation and
                dn is not None and len(dn) < 3):
            raise ValueError("Invalid value for `dn`, length must be greater than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                dn is not None and not re.search(r'^.+=.+$', dn)):  # noqa: E501
            raise ValueError(r"Invalid value for `dn`, must be a follow pattern or equal to `/^.+=.+$/`")  # noqa: E501

        self._dn = dn

    @property
    def uuid(self):
        """Gets the uuid of this InlineResponse201.  # noqa: E501

        The LDAP Entry-UUID.  # noqa: E501

        :return: The uuid of this InlineResponse201.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this InlineResponse201.

        The LDAP Entry-UUID.  # noqa: E501

        :param uuid: The uuid of this InlineResponse201.  # noqa: E501
        :type uuid: str
        """
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and len(uuid) > 36):
            raise ValueError("Invalid value for `uuid`, length must be less than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and len(uuid) < 36):
            raise ValueError("Invalid value for `uuid`, length must be greater than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and not re.search(r'^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$', uuid)):  # noqa: E501
            raise ValueError(r"Invalid value for `uuid`, must be a follow pattern or equal to `/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/`")  # noqa: E501

        self._uuid = uuid

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse201):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse201):
            return True

        return self.to_dict() != other.to_dict()
